/*
 * ************************************
 *  scoring
 * ************************************
 * 
 *  Created on: 18.01.2006
 *  Author: 	Harald Wendel
 *
 *  Revision:   $Revision$
 * 
 */
package scoring;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;

/**
 * @author hardi
 *
 */
public class ScoreDetailsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private Hit hit;
	
	public ScoreDetailsDialog(Hit hit) {
		super();
		this.hit = hit;
		
		setSize(880, 400);
		ScoreMain.centerComponent(this);
		
		add(createHitPanel());
	}
	
	public JPanel createHitPanel() {
		
		JPanel p = new JPanel();
		
		p.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		
		JPanel dataPanel = new JPanel();
		dataPanel.setLayout(new GridBagLayout());
		dataPanel.setBorder(BorderFactory.createTitledBorder("Berechnete Werte"));
		
	    c.gridx = 0;
	    c.gridy = 0;
	    c.fill = GridBagConstraints.BOTH;
	    c.anchor = GridBagConstraints.CENTER;
	    c.weightx = 0.1;
	    c.weighty = 1.0;
	    c.insets = new Insets(2, 2, 2, 2);
	    
	   
	    
	    dataPanel.add(new JLabel("Anfrage:"), c);
	    c.gridx = 1;
	    c.weightx = 1.0;
	    dataPanel.add(new JLabel(hit.getDescription().getQuery().getQueryStr()), c);
	    
	    
	    c.gridx = 0;
	    c.gridy = 1;
	    c.weightx = 0.1;
	    
	    dataPanel.add(new JLabel("Skalarprodukt (Anfragevektor, Dokumentvektor):"), c);
	    
	    c.gridx = 1;
	    
	    dataPanel.add(new JLabel(ScoreMain.FORMAT.format(
	    		hit.getDescription().getDotProduct())), c);
	    
	    c.gridx = 0;
	    c.gridy = 2;
	    c.weightx = 0.1;
	    
	    dataPanel.add(new JLabel("Betrag (Anfragevektor):"), c);
	    c.gridx = 1;
	    c.weightx = 1.0;
	    dataPanel.add(new JLabel(ScoreMain.FORMAT.format(
	    		hit.getDescription().getQueryVectorLength())), c);
	    
	    c.gridx = 0;
	    c.gridy = 3;
	    c.weightx = 0.1;
	    
	    dataPanel.add(new JLabel("Betrag (Dokumentvektor):"), c);
	    c.gridx = 1;
	    c.weightx = 1.0;
	    dataPanel.add(new JLabel(ScoreMain.FORMAT.format(
	    		hit.getDescription().getDocumentVectorLenght())), c);
	    
	    c.gridx = 0;
	    c.gridy = 4;
	    c.weightx = 1.0;
	    c.gridwidth = 2;
	    
	    dataPanel.add(new JSeparator(), c);
	    
	    c.gridy = 5;
	    c.weightx = 0.1;
	    
	    dataPanel.add(new JLabel("Score (Cosinus):"), c);
	    c.gridx = 1;
	    c.weightx = 1.0;
	    dataPanel.add(new JLabel(ScoreMain.FORMAT.format(
	    		hit.getScore())), c);
	    
	    c.gridx = 0;
	    c.gridy = 0;
	    c.gridwidth = 1;
	    c.weightx = 1.0;
	    c.weighty = 0.1;
	    
	    p.add(dataPanel, c);
	    
	    c.gridx = 0;
	    c.gridy = 1;
	    c.gridwidth = 1;
	    c.weightx = 1.0;
	    c.weighty = 3.0;
	    c.insets = new Insets (5, 7, 5, 7);
	    
	    JTable t = new JTable();
	    t.setModel(new DescriptionTableModel(hit));
		t.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		
		p.add(new JScrollPane(t), c);
	    
		
		return p;
	}
	
	public int doModal() {
        setTitle("Score Details");
        setVisible(true);
        return 0;
    }

}

