/*
 * ************************************
 *  scoring
 * ************************************
 * 
 *  Created on: 12.12.2005
 *  Author: 	Harald Wendel
 *
 *  Revision:   $Revision$
 * 
 */
package scoring.index;

import java.io.Reader;
import java.util.SortedMap;
import java.util.TreeMap;


/**
 * @author hardi
 *
 */
public class Document {
	
	private   String title;
	protected Reader r;
	protected SortedMap<Term, ValueHolder<Integer>> terms;
	
	private int maxTermCount = 0;
	

	public Document(String title, Reader r) {
		this.title = title;
		this.r = r;
		terms = new TreeMap<Term, ValueHolder<Integer>>(new TermComparator());
	}

	public String getTitle() {
		return title;
	}
	
	public void addTerm(Term t) {
		int val = 0;
		ValueHolder<Integer> h = terms.get(t);
		if (h == null) {
			terms.put(t, new ValueHolder<Integer>(1));
			val = 1;
		} else {
			val = h.getValue() + 1;
			h.setValue(val);
		}
		
		if (val > maxTermCount) {
			maxTermCount = val;
		}
	}
	
	public int getMaxTermCount() {
		return maxTermCount;
	}

	public Term[] terms() {
		return terms.keySet().toArray(new Term[] {});
	}

	@Override
	public String toString() {
		return "Document [" + title + "]";
	}

}
