/*
 * ************************************
 *  scoring
 * ************************************
 * 
 *  Created on: 12.12.2005
 *  Author: 	Harald Wendel
 *
 *  Revision:   $Revision$
 * 
 */
package scoring.index;

import java.util.SortedMap;
import java.util.TreeMap;


/**
 * @author hardi
 *
 */
public class Term {
	
	private String value;
	
	private SortedMap<Integer, ValueHolder<Integer>> docs;

	protected Term(String value) {
		this.value = value;
		docs = new TreeMap<Integer, ValueHolder<Integer>>(new IntComparator());
	}

	public String getValue() {
		return value;
	}
	
	public void addDoc(int doc) {
		ValueHolder<Integer> h = docs.get(doc);
		if (h == null) {
			docs.put(doc, new ValueHolder<Integer>(1));
		} else {
			h.setValue(h.getValue() + 1);
		}
	}
	
	public Integer[] getDocs() {
		return docs.keySet().toArray(new Integer[] {});
	}
	
	public int df() {
		return docs.size();
	}
	
	public int tf(int doc) {
		ValueHolder<Integer> h = docs.get(doc);
		return h == null ? 0 : h.getValue();
	}

	@Override
	public String toString() {
		return value;
	}
}
