/*
 * ************************************
 *  scoring
 * ************************************
 * 
 *  Created on: 12.12.2005
 *  Author: 	Harald Wendel
 *
 *  Revision:   $Revision$
 * 
 */
package scoring.index;

import java.io.IOException;
import java.io.Reader;

/**
 * @author hardi
 *
 */
public class Tokenizer {
	
	private int curSym;
    private Reader r;

	public Tokenizer(Reader r) {
		this.r = r;
	}
	
	private void nextChar() {
		try {
			curSym = r.read();
		} catch (IOException e) {
			e.printStackTrace();
            System.exit(1);
		}
	}
	
	public boolean hasMoreTokens() {
		return curSym != -1;
	}
	
	public String nextToken() {

		while (!Character.isLetterOrDigit((char)curSym)) {
			nextChar();
		}

		StringBuffer b = new StringBuffer();
	    
		while (Character.isLetterOrDigit((char)curSym)) {
			b.append((char)curSym);
			nextChar();
		}
			
		return b.toString();
	}

}
